#include "dump.h"
#include <iostream>

using namespace std;

struct base {
	virtual ~base() = default;

	int data{0x1020};

	virtual void fun(int x) = 0;
};

// begin dispatch:
void much_fun(base &x) {
	x.fun(100);
}
// end dispatch

struct derived : base {
	void fun(int x) override {
		cout << "Total: " << (x + data) << endl;
	}
};

int main() {
	derived d;
	dump_numeric(d);
	dump_pointers(d);

	dump_vtable(d, 4);

	return 0;
}
